      PROGRAM FIND_Q
C
C       COMPUTE EQUI-COORDINATE QUANTILE FOR A MULTIVARIATE
C       NORMAL OR A MULTIVARIATE T WITH PRODUCT CORRELATION
C       STRUCTURE USING MVSTUD AND MVNPRD.
C
      DIMENSION BPD(50)
      REAL TARGET,BL,CL,RE,AE
      INTEGER IFLAG
      COMMON /BLK1/ NDF,N,TARGET,BPD
      EXTERNAL QUADP
      DATA  ZERO, ONE / 0.0, 1.0  /
   10 WRITE (*,200)
      READ (*,*) N, NDF
      IF (N .LE. 0 .OR. NDF .LT. 0) STOP
      IF (N .GT. 50) THEN
         WRITE (*,300)
         STOP
      ELSE
         CONTINUE
      ENDIF
C
C       SPECIFY THE CORRELATION STRUCTURE:-
C       ENTER IX = 1 IF THERE IS A FIXED RHO
C          OR IX = 2 IF RHO IS DETERMINED FROM SAMPLE SIZES
C          OR IX = 3 IF RHO(I,J)=BPD(I)*BPD(J)
C
   20 WRITE (*,210)
      READ (*,*) IX
      IF (IX .LT. 1 .OR. IX .GT. 3) GO TO 10
      IF (IX .EQ. 1) THEN
   30    WRITE (*,220)
         READ (*,*) RHO
         IF (RHO .LT. ZERO .OR. RHO .GE. ONE) GO TO 30
         SQTRHO = ZERO
         IF (RHO .GT. ZERO) SQTRHO = SQRT(RHO)
         DO 40 I = 1, N
            BPD(I) = SQTRHO
   40    CONTINUE
      ELSE
         IF (IX .EQ. 2) THEN
            WRITE (*,310)
            READ (*,*) X0, (BPD(I), I = 1, N)
            DO 50 I = 1, N
               BPD(I) = ONE / SQRT(ONE + X0 / BPD(I))
   50       CONTINUE
         ELSE
   60       WRITE (*,230) N
            READ (*,*) (BPD(I), I = 1, N)
         ENDIF
      ENDIF
C
C       SPECIFY THE PROBABILITY 
C
 120	WRITE(*,600) 
	READ(*,*) TARGET
 600  FORMAT(1X,'Enter Quantile Probability')
      BL = 0.0
      CL = 6.0
      RE = .001
      AE = .0001
      CALL ZEROIN(QUADP,BL,CL,RE,AE,IFLAG)
      print*,bL,cL
      WRITE (*,170) 
      READ (*,*) IX
      IF (IX .EQ. 1) GO TO 120
      GO TO 10
  170 FORMAT(1X,'Enter 1 to repeat with new coverage or 0', 
     *' for new problem')
c  180 FORMAT(1X,'First',I2,' parameter sets:-',
c     *       /,1X,' I     L_i     U_i    TYPE      b_i     \mu_i')
  190 FORMAT(1X,I2,2F9.3,I6,2F9.3)
  200 FORMAT(1X,'Enter P = No. Dimensions, and D.o.F. (0 for MVN)',
     */1X,'(or 0 0 to terminate)')
c  205 FORMAT(1X,'Enter 0 for central case')
  210 FORMAT(1X,'Enter 1 for equal-rho case,'/
     *       1X,'   or 2 to compute rho_ij from sample sizes,'/
     *       1X,'   or 3 if rho_ij = b_i*b_j')
  220 FORMAT(1X,'Enter common rho')
  230 FORMAT(1X,'Enter b_i, i = 1, ',I3)
c  240 FORMAT(1X,'Enter 1 for a common set of limits and 0 if not')
  245 FORMAT(1X,'Enter desired quadrant probility'/)
c  250 FORMAT(1X,'Enter common values of TYPE and limit(s)')
c  260 FORMAT(1X,'Enter TYPE and limit(s) for I =',I3)
c  270 FORMAT(1X,'Enter',I3,' mean value(s)')
  280 FORMAT(1X,'PROB  =',F10.6,/,1X,'BOUND =',F10.6,/,1X,
     *	'FAULT =',I10,/)
  290 FORMAT(/,1X,'Computed results for N =',I3,', NDF =',I4,':-')
  300 FORMAT(1X,'DIMENSION LIMITS EXCEEDED',/)
  310 FORMAT(1X,'Enter sample sizes (control first)',/)
      END
C
      SUBROUTINE ZEROIN(F,B,C,RE,AE,IFLAG)
C
C     SANDIA MATHEMATICAL PROGRAM LIBRARY
C     MATHEMATICAL COMPUTING SERVICES DIVISION 5422
C     SANDIA LABORATORIES
C     P. O. BOX 5800
C     ALBUQUERQUE, NEW MEXICO  87115
C     CONTROL DATA 6600 VERSION 4.5, 1 NOVEMBER 1971
C
C     MODIFIED TO RUN AT NBS BY D. KAHANER DIV 713
C
C     ABSTRACT
C        ZEROIN SEARCHES FOR A ZERO OF A FUNCTION F(X) BETWEEN
C        THE GIVEN VALUES B AND C UNTIL THE WIDTH OF THE INTERVAL
C        (B,C) HAS COLLAPSED TO WITHIN A TOLERANCE SPECIFIED BY
C        THE STOPPING CRITERION, ABS(B-C) .LE. 2.*(RW*ABS(B)+AE).
C
C     DESCRIPTION OF ARGUMENTS
C        F     - NAME OF THE REAL VALUED EXTERNAL FUNCTION.  THIS NAME
C                MUST BE IN AN EXTERNAL STATEMENT IN THE CALLING
C                PROGRAM.  F MUST BE A FUNCTION OF ONE REAL ARGUMENT.
C        B     - ONE END OF THE INTERVAL (B,C).  THE VALUE RETURNED FOR
C                B USUALLY IS THE BETTER APPROXIMATION TO A ZERO OF F.
C        C     - THE OTHER END OF THE INTERVAL (B,C)
C        RE    - RELATIVE ERROR USED FOR RW IN THE STOPPING CRITERION.
C                IF THE REQUESTED RE IS LESS THAN MACHINE PRECISION,
C                THEN RW IS SET TO APPROXIMATELY MACHINE PRECISION.
C        AE    - ABSOLUTE ERROR USED IN THE STOPPING CRITERION.  IF THE
C                GIVEN INTERVAL (B,C) CONTAINS THE ORIGIN, THEN A
C                NONZERO VALUE SHOULD BE CHOSEN FOR AE.
C        IFLAG - RETURNS A STATUS OF THE RESULTS INDICATING WHICH
C                OF THE FOLLOWING CONDITIONS HOLD.
C                    A - ABS(B-C) .LE. 2.*(RW*ABS(B)+AE)
C                    B - F(B) * F(C) .LT. 0.
C                    C - ABS(F(B)) .LE. ABS(F(C))
C                    D - ABS(F(B   )) .LE. MAX(ABS(F(B  )),ABS(F(C  )))
C                               OUT                   IN          IN
C                    E - NUMBER OF EVALUATIONS OF F(X) .LE. 500
C               =1 INDICATES NORMAL CASE.  ALL CONDITIONS ABOVE HOLD.
C               =2 INDICATES F(B) = 0.  CONDITION A MAY NOT HOLD.
C               =3 INDICATES CONDITIONS A, B, C, AND E HOLD BUT D DOES
C                  NOT.  (B,C) PROBABLY CONTAINS A SINGULAR POINT OF F.
C               =4 INDICATES CONDITIONS A AND E HOLD BUT B DOES NOT.
C                  A LOCAL MINIMUM OF F(X) IN (B,C) MAY HAVE BEEN FOUND.
C               =5 INDICATES SEARCH WAS ABORTED WHEN CONDITION E FAILED.
C
C     REFERENCES
C       1.  L F SHAMPINE AND H A WATTS, ZEROIN, A ROOT-SOLVING CODE,
C           SC-TM-70-631, SEPT 1970.
C       2.  T J DEKKER, FINDING A ZERO BY MEANS OF SUCCESSIVE LINEAR
C           INTERPOLATION, *CONSTRUCTIVE ASPECTS OF THE FUNDAMENTAL
C           THEOREM OF ALGEBRA*, EDITED BY B DEJON AND P HENRICI, 1969.
C
C     INITIALIZE
      external f
      DATA ER/0.0/
c      IF (ER .EQ. 0.0) ER = 4. * (R1MACH (4) )
      IF (ER .EQ. 0.0) ER = 4. * (.0000001 )
      RW=AMAX1(RE,ER)
      IC=0
      ACBS=ABS(B-C)
      A=C
      FA=F(A)
      FB=F(B)
      FC=FA
      KOUNT=2
      FX=AMAX1(ABS(FB),ABS(FC))
C
    1 IF (ABS(FC) .GE. ABS(FB)) GO TO 2
C     PERFORM INTERCHANGE
      A=B
      FA=FB
      B=C
      FB=FC
      C=A
      FC=FA
C
    2 CMB=0.5*(C-B)
      ACMB=ABS(CMB)
      TOL=RW*ABS(B)+AE
C
C     TEST STOPPING CRITERION
      IF (ACMB .LE. TOL) GO TO 10
C
C     CALCULATE NEW ITERATE IMPLICITLY AS B+P/Q
C     WHERE WE ARRANGE P .GE. 0.
C     THE IMPLICIT FORM IS USED TO PREVENT OVERFLOW.
      P=(B-A)*FB
      Q=FA-FB
      IF (P .GE. 0.) GO TO 3
      P=-P
      Q=-Q
C
C     UPDATE A AND CHECK FOR SATISFACTORY REDUCTION
C     IN THE SIZE OF OUR BOUNDING INTERVAL.
    3 A=B
      FA=FB
      IC=IC+1
      IF (IC .LT. 4) GO TO 4
      IF (8.*ACMB .GE. ACBS) GO TO 6
      IC=0
      ACBS=ACMB
C
C     TEST FOR TOO SMALL A CHANGE
    4 IF (P .GT. ABS(Q)*TOL) GO TO 5
C
C     INCREMENT BY TOLERANCE
      B=B+SIGN(TOL,CMB)
      GO TO 7
C
C     ROOT OUGHT TO BE BETWEEN B AND (C+B)/2.
    5 IF (P .GE. CMB*Q) GO TO 6
C
C     INTERPOLATE
      B=B+P/Q
      GO TO 7
C
    6 B=0.5*(C+B)
C     BISECT
C
C     HAVE COMPLETED COMPUTATION FOR NEW ITERATE B
    7 FB=F(B)
      IF (FB .EQ. 0.) GO TO 11
      KOUNT=KOUNT+1
      IF (KOUNT .GT. 500) GO TO 15
C
C     DECIDE WHETHER NEXT STEP IS INTERPOLATION OR EXTRAPOLATION
      IF (SIGN(1.0,FB) .NE. SIGN(1.0,FC)) GO TO 1
      C=A
      FC=FA
      GO TO 1
C
C
C     FINISHED. PROCESS RESULTS FOR PROPER SETTING OF IFLAG
C
   10 IF (FB*FC .GT. 0.) GO TO 13
      IF (ABS(FB) .GT. FX) GO TO 12
      IFLAG = 1
      RETURN
   11 IFLAG = 2
      RETURN
   12 IFLAG = 3
      RETURN
   13 IFLAG = 4
      RETURN
   15 IFLAG = 5
      RETURN
      END
C
C
      FUNCTION QUADP(X)
      IMPLICIT NONE
      REAL A(50),B(50),BPD(50),D(50)
      REAL QUADP,X,EPS,HNC,PROB,BND,ZERO,TARGET
      INTEGER NDF,N,INF(50),IERC,IFLT,I
      COMMON /BLK1/ NDF,N,TARGET,BPD
      DATA ZERO,EPS   / 0.0, 0.0001 /
      IERC = 0
      HNC = ZERO
      DO 90 I = 1, N
         D(I) = ZERO
         B(I) = ZERO
         A(I) = X
         INF(I) = 1
 90   CONTINUE
      CALL MVSTUD(NDF,A,B,BPD,EPS,N,INF,D,IERC,HNC,PROB,BND,IFLT) 
      QUADP = PROB -TARGET 
      RETURN
      END
