      DOUBLE PRECISION FUNCTION PCSNB(T,N,DSTAR,SIGMA)
C
C     EVALUATE P{CS} USING PROCEDURE N_B WHEN THE TRUE MEANS ARE IN 
C     THE SLIPPAGE CONFIG, THE MEASUREMENT ERROR FOR EACH TREATMENT IS 
C     SPECIFIED BY SIGMA, AND THE SAMPLE SIZE OF THE TREATMENT 
C     ASSOCIATED WITH THE ITH ORDERED MEAN IS N(I).  
C
C  INPUT: T       = NUMBER OF TREATMENTS (T .LEQ. 50 - RESET BY MAXT)
C         N(I)    = SAMPLE SIZE OF THE TREATMENT ASSOCIATED WITH THE 
C                   ITH ORDERED MEAN MU[I]
C         DSTAR   = DIFFERENCE TO BE DETECTED 
C         SIGMA   = STANDARD DEVIATION OF THE MEASURE ERROR
C
C  OUTPUT: PROBABILITY OF CORRECT SELECTION USING N_B
C
      INTEGER MAXT
C     MAXT DEFINES THE MAXIMUM NUMBER OF TREATMENTS
      PARAMETER (MAXT=50)
      DOUBLE PRECISION ZCDF
      DOUBLE PRECISION DSTAR,SIGMA
      DOUBLE PRECISION DN(MAXT),X(32),W(32),WEX(32),DUMP,DUMN,ANS
      INTEGER T,N(MAXT),I,LK,TM1
      EXTERNAL ZCDF
      INCLUDE 'GLQUAD'
C
      DO 100 I = 1,T
100   DN(I) = DSQRT(DFLOAT(N(I)))
      TM1 = T - 1 
C
      ANS = 0.0D0
C
C     EVALUATE P{CS} 
C
      DO 110 I = 1,32
      DUMP = 1.0D0
      DUMN = 1.0D0
      DO 120 LK = 1,TM1
      DUMP = DUMP * ZCDF(X(I) * DN(LK)/DN(T) + DN(LK) * DSTAR/SIGMA)
      DUMN = DUMN * ZCDF(-X(I) * DN(LK)/DN(T) + DN(LK) * DSTAR/SIGMA)
120   CONTINUE
      ANS = ANS + WEX(I)*(DUMP+DUMN)*0.3989422803*DEXP(-X(I)*X(I)/2.0D0)
110   CONTINUE
      PCSNB = ANS
      RETURN
      END

