      DOUBLE PRECISION FUNCTION PCSNGS(T,Q,N,DSTAR,SIGMA,H)
C
C     EVALUATE P{CS} USING PROCEDURE N_{GSa} AT THE SLIPPAGE 
C     CONFIGURATION (0,...,0,DSTAR) WHEN SIGMA IS STANDARD DEVIATION OF
C     THE MEASUREMENT ERROR FOR GIVEN T, Q, N AND YARDSTICK H 
C
C INPUT: T         = NUMBER OF TREATMENTS 
C        Q         = SIZE OF THE SUBSET
C        N         = COMMON SAMPLE SIZE
C        DSTAR     = DIFFERENCE TO BE DETECTED 
C        SIGMA     = STANDARD DEVIATION OF THE MEASURE ERROR
C        H         = CRITICAL VALUE CHOSEN TO GUARANTEE PROBABILITY
C                    P-STAR OF DELTA-STAR CS FOR GIVEN (N, SIGMA)
C
C OUTPUT: PROBABILITY OF CORRECT SELECTION FOR N_{GSa}
C
      DOUBLE PRECISION ZCDF,FACTOR
      DOUBLE PRECISION DSTAR,SIGMA,H
      DOUBLE PRECISION DN,CONST,X(32),W(32),WEX(32),DUMP,DUMN,
     *ANS,ANS1
      INTEGER T,Q,N,I,J,TM1,TMQ
      EXTERNAL ZCDF,FACTOR
C
      INCLUDE 'GLQUAD'
C
      DN = DSQRT(DFLOAT(N))
      TM1 = T - 1
      TMQ = T - Q
      CONST = DN*DSTAR/SIGMA
C
      ANS = 0.0D0
C
C     EVALUATE P{CS} 
C
      DO 100 I = TMQ,TM1
      ANS1 = 0.0D0
      DO 120 J = 1,32
      DUMP = ((ZCDF(X(J)+CONST))**I)*((ZCDF(X(J)+H*
     *DSQRT(DFLOAT(2))+CONST)-ZCDF(X(J)+CONST))**(TM1-I))
      DUMN = ((ZCDF(-X(J)+CONST))**I)*((ZCDF(-X(J)+H*
     *DSQRT(DFLOAT(2))+CONST)-ZCDF(-X(J)+CONST))**(TM1-I))
      ANS1 = ANS1+WEX(J)*(DUMP+DUMN)*0.3989422803D0*
     *DEXP(-X(J)*X(J)/2.0D0)
120   CONTINUE
      ANS = ANS + FACTOR(TM1,I)*ANS1
100   CONTINUE
      PCSNGS = ANS
C
      RETURN
      END

