      FUNCTION RNORML(IX)
C
C     GIVES N(0,1) DEVIATE BY COMPOSITION METHOD OF AHRENS AND DIETER.
C     SEE BRATLEY, FOX, AND SCHRAGE (1987), P. 330.
C
C     INPUT:  IX = INTEGER > 0 BUT < 2147483647
C     OUTPUT:  IX = NEW SEED, RNORML = N(0,1) DEVIATE
C
      U = UNIF(IX)
      U0 = UNIF(IX)
      IF(U.GE. 0.919544)GOTO 160
C
      RNORML = 2.40376*(U0+U*.825339)-2.11403
      RETURN
160   IF(U.LT. 0.965487)GOTO 210
C
180   RNORML = (4.46911-2*ALOG(UNIF(IX)))**0.5
      IF(RNORML*UNIF(IX).GT. 2.11403)GOTO 180
      GOTO 340
210   IF(U.LT. 0.949991)GOTO 260
C
230   RNORML = 1.8404+UNIF(IX)*0.273629
      IF(0.398942*EXP(-RNORML*RNORML/2)-0.443299+
     &  RNORML*0.209694 .LT. UNIF(IX)*4.27026E-02)GOTO 230
      GOTO 340
260   IF(U.LT. 0.925852)GOTO 310
C
280   RNORML = 0.28973+UNIF(IX)*1.55067
      IF(0.398942*EXP(-RNORML*RNORML/2)-0.443299+
     &  RNORML*.209694 .LT. UNIF(IX)*1.59745E-02)GOTO 280
      GOTO 340
310   RNORML = UNIF(IX)*0.28973
C
      IF(0.398942*EXP(-RNORML*RNORML/2)-0.382545
     &  .LT. UNIF(IX)*1.63977E-02)GOTO 310
340   IF(U0.GT. 0.5)GOTO 370
      RNORML = -RNORML
370   RETURN
      END

