      DOUBLE PRECISION FUNCTION ZCDF(UU)
C
C     APPROXMATE N(0,1) CDF USING ABRAMOWITZ AND STEGUN (1972) - 26.2.17
C
      DOUBLE PRECISION UU,B(5),P,T,TEMP,IRT2PI
C
      IF (UU.GT.5.) THEN
                ZCDF = 1.0D0 
                RETURN
      ENDIF
C
      P = 0.2316419
      DATA B/0.319381530, -0.356563782, 1.781477937, -1.821255978,
     *   1.330274429/
      IRT2PI = 0.3989422803     
C
      T = 1.0D0/(1.0D0 + P*DABS(UU))
      TEMP = ((((B(5)*T + B(4))*T + B(3))*T + B(2))*T + B(1))*T
C
      ZCDF = 1.0D0 - TEMP*DEXP(-UU*UU*0.5D0)*IRT2PI
      IF (UU .LT. 0.0D0) ZCDF = 1.0D0 - ZCDF
      RETURN
      END

